#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "common.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "init_file.h"
#include "mpglib/mpg123.h"
#include "mpglib/mpglib.h"

struct mp3info *read_tag(char *filename);
char *get_id3tag (int filedes);
char *reduce_name(char *longname);
int getfsize (int filedes);
char *combinename (char *filename, char *tag);

struct mp3info *read_tag(char *filename)
{
	struct mp3info *get_info;
	int filedes;
	char *tag;
	char buf_in[1024];
	
	get_info = (struct mp3info *) malloc(sizeof(struct mp3info));
	get_info->filename = (char *)malloc (strlen(filename)+1);
	strcpy (get_info->filename,filename);
	
	filedes = open(filename,O_RDONLY);
	
	tag = get_id3tag(filedes);
	get_info->songname = reduce_name(get_info->filename);
	if (tag != NULL) {
		free (get_info->songname);
		get_info->songname = combinename (get_info->filename, tag);
		free (tag);
	} 
	get_info->length = getfsize(filedes);
	get_info->selection = NOT_SELECTED;
	read (filedes, buf_in, 1024);
	if (header_info(buf_in, 1024, &(get_info->bitrate), &(get_info->framesize)) == MP3_ERR)  {
		get_info->bitrate = 128;
		get_info->framesize = 417;
	}
	printf ("%s, %i\n", get_info->songname, get_info->framesize);
	get_info->seconds = (get_info->length/(get_info->bitrate*128));
	close (filedes);
	return get_info;
}

/* This function returns the id3 tag */
char *get_id3tag (int filedes)
{
	char *newtag;
	char test[3];
	lseek (filedes, -128, SEEK_END);
	read (filedes, test,3);
	if (test[0] == 'T' && test[1] == 'A' && test[2] == 'G') { 
		newtag = (char*)malloc (125);
		read (filedes, newtag, 125);
		return newtag;
	}
	return NULL;
}

char *reduce_name(char *longname)
{
	int i;
	int laatste = 0;
	char *shortname;
	for(i=0;i<strlen(longname);i++)
		{
			if (longname[i] == 47) laatste = i+1;
		}
	shortname = (char *) malloc(strlen(longname)-laatste-3);
	for (i=laatste;i<strlen(longname)-4;i++)
		shortname[i-laatste] = longname[i];
	shortname [strlen(longname) - laatste -4] = 0;
	return shortname;
}

int getfsize (int filedes)
{
	struct stat *status;
	int filesize;
	status = (struct stat *)malloc(sizeof(struct stat));
	fstat (filedes, status);
	filesize = status->st_size;
	free(status);
	return filesize;
}

/* this function combines the filename and id3tag to the best possible name */
char *combinename (char *filename, char *tag)
{
	char *total;
	int i, j;
	for (i=29;i>0;i--) {
		if (tag[i] != 32) break;
	}
	i++;
	for (j=29;j>0;j--) {
		if (tag[j+30] != 32) break;
	}
	j++;
	total = (char *)malloc (i+j+4);
	strncpy (total,tag+30,j);
	total[j] = 0;
	strcat (total," - ");
	strncat (total, tag,i);
	return total;
}
